import Node = cc.Node;
import property = cc._decorator.property;
import Size = cc.Size;

const {ccclass} = cc._decorator;

@ccclass
export default class Test extends cc.Component
{
    @property(Number)
    public m_iSpeed: number = 5;
    @property(Number)
    public m_iCreateInterval: number = 100;
    @property(Number)
    public m_iMaxBiuCnt: number = 200;

    private m_ndBiu: Node;
    private m_arrBiuPool: Array<Node>;
    private m_arrBiuRunning: Array<Node>;
    private m_stSize: Size;
    private m_iTotDistance: number;

    onLoad ()
    {
        this.m_ndBiu = cc.find("Canvas/biubiubiu");
        this.m_ndBiu.active = false;

        this.m_arrBiuPool = new Array<Node>();
        this.m_arrBiuRunning = new Array<Node>();
        this.m_stSize = cc.view.getDesignResolutionSize();
        this.m_iTotDistance = 0;
    }

    start ()
    {

    }

    update (dt)
    {
        if (this.m_arrBiuRunning.length <= 0 || this.m_iTotDistance % this.m_iCreateInterval == 0 && this.m_arrBiuRunning.length <= this.m_iMaxBiuCnt)
        {
            this.CreateBiu();
        }

        for (let i: number = 0; i < this.m_arrBiuRunning.length; ++i)
        {
            this.m_arrBiuRunning[i].y += this.m_iSpeed;

            // 销毁出镜的。
            if (this.m_arrBiuRunning[i].y >= this.m_stSize.height / 2)
            {
                this.m_arrBiuRunning[i].active = false;
                this.m_arrBiuPool.push(this.m_arrBiuRunning.splice(i, 1)[0]);
                --i;

                // 销毁一个新增一个。
                this.CreateBiu();
            }
        }

        this.m_iTotDistance += this.m_iSpeed;
    }

    private CreateBiu(): void
    {
        let ndBiu: Node;
        if (this.m_arrBiuPool.length <= 0)
            ndBiu = cc.instantiate(this.m_ndBiu);
        else
            ndBiu = this.m_arrBiuPool.pop();
        ndBiu.active = true;
        ndBiu.x = (Math.random() >= 0.5 ? -1 : 1) * Math.random() * 265;
        ndBiu.y = - this.m_stSize.height / 2;
        if (ndBiu.parent != cc.Canvas.instance.node)
        {
            ndBiu.removeFromParent();
            cc.Canvas.instance.node.addChild(ndBiu);
        }

        this.m_arrBiuRunning.push(ndBiu);
    }
}
